<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wworkflow_models_wfcase extends wPrototype
{

public function __construct($objtype = '', $id = '')
{
    parent::__construct('wwf_wfcase');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
}


protected function _onBeforeInsert()
{
    global $parser;
    // Check for atart and finish transitions in workflow
    $n = $parser->utils->getFieldFromSql("SELECT COUNT(*) AS SNUM
                                          FROM wwf_wftrans
                                          WHERE (wfid=".$this->getFieldNewVal('wfid').")
                                          AND (start=1)
                                          ", 0);
    if(!$n) return $parser->gt('nostarttrans');
    if($n > 1) return $parser->gt('moreonestarttrans');
    $n = $parser->utils->getFieldFromSql("SELECT COUNT(*) AS SNUM
                                          FROM wwf_wftrans
                                          WHERE (wfid=".$this->getFieldNewVal('wfid').")
                                          AND (finish=1)
                                          ", 0);
    if(!$n) return $parser->gt('nofinishtrans');

    $this->setFieldNewVal('creatby', $parser->getUserId());
    $this->setFieldNewVal('creaton', $parser->utils->toDate('', true));
    return '';
}

protected function _onInsert()
{
    global $parser;
    $n = $parser->utils->getFieldFromSql("SELECT id
                                          FROM wwf_wftrans
                                          WHERE (wfid=".$this->getFieldNewVal('wfid').")
                                          AND (start=1)
                                          ", 0);
    if(!$n) return $parser->gt('nostarttrans');
    $f = new wworkflow_models_wfoper();
    $f->fire($this->id, $n);
    return ''; // Do not return anything in any case
}

protected function _onBeforeShowForm()
{
    global $parser;
    if(!$this->id)
    {
        if(!$this->getFieldNewVal('wfid'))  $this->setFieldattr('wfid', 'ro', 0);
    } else
    {
        if($this->getFieldVal('wfid'))
        {
            $this->setFieldAttr('wfid', 'labelfunc', "openWinc('".$parser->makeUrl('wwf_wflow_card')."', '&objid=:value:'); return false;");

        }

        if($this->getFieldVal('objtype') and $this->getFieldVal('objid'))
        {
            $this->setFieldAttr('objtype', 'hide', 1);
            $this->setFieldAttr('objid', 'hide', 0);
            $this->setFieldAttr('objid', 'ro', 1);
            $a = $parser->utils->getObjInfo($this->getFieldVal('objtype'), $this->getFieldVal('objid'));
            $this->setFieldAttr('objid', 'label', $a['objtypename']);
            $this->setFieldAttr('objid', 'notes', $a['name']);
            if($a['card'])
            $this->setFieldAttr('objid', 'labelfunc', "openWinc('".$parser->makeUrl($a['card'])."', '&objid=:value:'); return false;");
        }

    }
    return '';
}

protected function _onBeforeDelete()
{
    global $parser;
    $s = $this->canDelete();
    if($s) return $s;

    $n = $parser->utils->getFieldFromSql("SELECT id
                                          FROM wwf_wftrans
                                          WHERE (wfid=".$this->getFieldNewVal('wfid').")
                                          AND (start=1)
                                          ", 0);
    if(!$n) return $parser->gt('nostarttrans');
    $f = new wworkflow_models_wfoper();
    $f->caseid = $this->id;

    // 1. Find all pathes from this point
    $pathes = $f->getChilds($n);
    // 2. All conditions must be true
    $s = $f->_goback($this->id, $n, $pathes);
    if($s) return $s;
    $parser->conn->Execute("DELETE FROM wwf_wfoper WHERE caseid=".$this->id);
    return '';
}

public function canDelete()
{
    global $parser;
    $n = $parser->utils->getFieldFromSql("SELECT id
                                          FROM wwf_wftrans
                                          WHERE (wfid=".$this->getFieldNewVal('wfid').")
                                          AND (start=1)
                                          ", 0);
    if(!$n) return $parser->gt('nostarttrans');
    $f = new wworkflow_models_wfoper();
    $f->caseid = $this->id;

    // 1. Find all pathes from this point
    $pathes = $f->getChilds($n);
    // 2. All conditions must be true
    return $f->_goback($this->id, $n, $pathes, true);
}


}

?>