<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wworkflow_models_wflow extends wPrototype
{
public $caseid = 0;

public function __construct($objtype = '', $id = '')
{
    parent::__construct('wwf_wflow');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
    $this->showformTinymceScript = true;
    $this->richedit_height = 300;
}

public function getXml($trans = 0, $doprint = false)
{
    global $parser;
    if($doprint)
    {
        if(ob_get_length()) ob_clean();
    	header('Expires: Mon, 26 Jul 1997 05:00:00 GMT' );
    	header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . 'GMT');
    	header('Cache-Control: no-cache, must-revalidate');
    	header('Pragma: no-cache');
    	header('Content-Type: text/xml');
	}
	$outstr = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
	$outstr .= "<rows infotype='data'>\n";

    // 1. Send transitions
    $extra = ($trans) ? "AND (o.id IN(".$trans."))" : '';
    $sql = "SELECT o.id, o.title, o.trcode, o.subwfid, o.topcorner, o.leftcorner,
            o.boxwidth, o.boxheight, o.notes, 0 AS state, o.triggertype,
            o.incbranch, o.outbranch, o.start, o.finish
            FROM wwf_wftrans o
            WHERE (o.wfid=".$this->id.") ".$extra;
    $rs = $parser->conn->Execute($sql);
    $t = 0;
    $user = $parser->getUserId();
    while($row = $rs->FetchRow())
    {
        $headerclass = '';
        $state = '';
        $editable = 0;
        $subcaseid = 0;
        $task = '';
        $timeout = '';

        if($this->caseid)
        {
            $a = $parser->utils->getFieldsFromSql("SELECT o.id, o.state,
                                                  t.triggertype, c.ref1 AS cref1, t.roleid, t.userid,
                                                  r.name_".$parser->lang_suff." AS rname, r.ref1 AS rref1,
                                                  o.timeout
                                                  FROM wwf_wfoper o, wwf_wftrans t, sys_objects c, sys_objects r
                                                  WHERE (o.caseid=".$this->caseid.")
                                                  AND (o.transid=".$row[0].")
                                                  AND (o.transid=t.id)
                                                  AND (o.state=c.objid)
                                                  AND (t.taskid=r.objid)
                                                  ORDER BY o.id DESC
                                                  ", array(0, 0, 0, '', 0, 0,0,0,''), 'num');
            if($a[0])
            {
                if($row[3]) $subcaseid = $parser->utils->getFieldFromSql('SELECT id FROM wwf_wfcase WHERE parentoper='.$a[0], 0);
                $headerclass = $a[3];
                $state = $a[1];
                if($parser->isSuperAdmin()) $editable = 1;
                else
                {
                    if($a[5] and (''.$user == $a[5])) $editable = 1;
                    if($a[4] and $parser->checkRoles(array($a[4]))) $editable = 1;
                    if(!$a[4] and !$a[5]) $editable = 1;
                }
                if($a[7] and $editable)
                {
                    $b = $parser->utils->getFieldsFromSql("SELECT objtype, objid
                                                  FROM wwf_wfcase
                                                  WHERE (id=".$this->caseid.")
                                                  ", array(0, 0), 'num');
                    $task = "<a href=\"\" onclick=\"openWinc('".$parser->makeUrl($a[7]).
                    "', 'caseid=".$this->caseid."&caseoperid=".$a[0]."&master_objtype=".$b[0]."&master_objid=".$b[1]."');return false;\"><img src=\"".SYS_BASE_URL."main/images/icons/page-small.png\" alt=\"\" title=\"".$a[6]."\"/></a>";
                }

                $timeout = $parser->utils->isoToDateformat($a[8], true);
            }
        }
        $outstr .= "<row infotype='transition' headerclass='".$headerclass."' contentclass='' state='".$state."' editable='".$editable."'>\n";
        $outstr .= "<cell>".$row[0]."</cell>\n";                                      // 0 - id
        $outstr .= "<cell><![CDATA[".$row[1]."]]></cell>\n";                          // 1 - title
        $outstr .= "<cell><![CDATA[".(($row[2]) ? $row[2] : $row[0])."]]></cell>\n";  // 2 - code
        $outstr .= "<cell>".$row[3]."</cell>\n";                                      // 3 - subworkflow
        $outstr .= "<cell>".$row[4]."</cell>\n";                                      // 4 - topcorner
        $outstr .= "<cell>".$row[5]."</cell>\n";                                      // 5 - leftcorner
        $outstr .= "<cell>".$row[6]."</cell>\n";                                      // 6 - width
        $outstr .= "<cell>".$row[7]."</cell>\n";                                      // 7 - height
        $outstr .= "<cell><![CDATA[".$row[8]."]]></cell>\n";                          // 8 - notes
        $outstr .= "<cell><![CDATA[".$row[9]."]]></cell>\n";                          // 9 - state
        $outstr .= "<cell>".$subcaseid."</cell>\n";                                   // 10 - subprocess id
        $outstr .= "<cell><![CDATA[".$task."]]></cell>\n";                            // 11 - task
        $outstr .= "<cell><![CDATA[".$row[10]."]]></cell>\n";                         // 12 - triggertype
        $outstr .= "<cell><![CDATA[".$timeout."]]></cell>\n";                         // 13 - timeout
        $outstr .= "<cell><![CDATA[".$row[11]."]]></cell>\n";                         // 14 - input branching
        $outstr .= "<cell><![CDATA[".$row[12]."]]></cell>\n";                         // 15 - output branching
        $outstr .= "<cell>".$row[13]."</cell>\n";                                     // 16 - start
        $outstr .= "<cell>".$row[14]."</cell>\n";                                     // 17 - finish
        $outstr .= "</row>\n";
        $t++;
    }
    // 1. Send connections
    $extra = ($trans) ? " AND ((o.fromtrans IN(".$trans.")) OR (o.totrans IN(".$trans.")))" : '';
    $sql = "SELECT o.id, o.fromtrans,
            f.topcorner AS ftopcorner, f.leftcorner AS fleftcorner,
            f.boxwidth AS fboxwidth, f.boxheight AS fboxheight,
            o.totrans,
            t.topcorner AS ttopcorner, t.leftcorner AS tleftcorner,
            t.boxwidth AS tboxwidth, t.boxheight AS tboxheight,
            o.forwardcond, o.backwardcond
            FROM wwf_conns o, wwf_wftrans f, wwf_wftrans t
            WHERE (f.wfid=".$this->id.")
            AND (o.fromtrans=f.id)
            AND (o.totrans=t.id)
            ".$extra;
    $rs = $parser->conn->Execute($sql);
    $c = 0;
    while($row = $rs->FetchRow())
    {
        // Calculate coordinates
        $id = $row[0];
        $stroke = (trim($row[11]) or trim($row[12])) ? 2 : 1;
        $padding = 3 * 2;
        $fx = $row[3];
        $fy = $row[2];
        $fw = $row[4] + $padding;
        $fh = $row[5] + $padding;
        $tx = $row[8];
        $ty = $row[7];
        $tw = $row[9] + $padding;
        $th = $row[10] + $padding;

        $startx = 0;
        $starty = 0;
        $angle = 0;

        // Find the shottest path
        $path = 'tb';
        $min = sqrt(pow($fx + $fw / 2 - $tx - $tw / 2, 2) + pow($fy - $ty - $th, 2));
        $rl = sqrt(pow($fx + $fw - $tx, 2) + pow($fy + $fh /2  - $ty - $th / 2, 2));
        if($rl < $min) {$path = 'rl';$min = $rl;}
        $bt = sqrt(pow($fx + $fw / 2 - $tx - $tw / 2, 2) + pow($fy + $fh  - $ty, 2));
        if($bt < $min) {$path = 'bt';$min = $bt;}
        $lr = sqrt(pow($fx - $tw - $tx, 2) + pow($fy + $fh /2  - $ty - $th / 2, 2));
        if($lr < $min) {$path = 'lr';$min = $lr;}
        switch($path)
        {
            case 'tb';
                $startx = floor($fx + $fw / 2);
                $starty = $fy;
                $angle = ($min) ?  acos(($tx + $tw /2 -$fx - $fw /2) / $min ) : 0;
            break;
            case 'rl';
                $startx = $fx + $fw;
                $starty = floor($fy + $fh / 2);
                $angle = ($min) ? acos(($tx - $fx - $fw) / $min ) : 0;
                if($ty > $fy) $angle = - $angle;
            break;
            case 'bt';
                $startx = floor($fx + $fw / 2);
                $starty = $fy + $fh;
                $angle = ($min) ? - acos(($tx + $tw /2 -$fx - $fw /2) / $min ) : 0;
            break;
            case 'lr';
                $startx = $fx;
                $starty = floor($fy + $fh / 2);
                $angle = ($min) ? acos(($tx + $tw - $fx) / $min ) : 0;
                if($ty > $fy) $angle = - $angle;
            break;
        }

        $outstr .= "<row infotype='connection' id='".$id."' startx='".$startx."' starty='".$starty."' len='".$min."' angle='".$angle."' fromid='".$row[1]."' toid='".$row[6]."' stroke='".$stroke."' path='".$path."'>\n";
        $outstr .= "</row>\n";
        $c++;
    }

	$outstr .= '</rows>';
    //$parser->toFile($outstr, SYS_BASE_PATH.'userdata/wf.xml');
    if($doprint) die($outstr);
    if(!$t and !$c) $outstr = '';
    return $outstr;
}

public function startCase($id = 0, $type = 0, $objtype = '0', $objid = '0')
{
    global $parser;
    if(!$type) return '';
    $f = new wworkflow_models_wfcase();
    $sql = "SELECT id
          FROM wwf_wflow
          WHERE (published=1)
          AND (eventtype='".$type."')
          ";
    $rs = $parser->conn->Execute($sql);
    while($row = $rs->FetchRow())
    {
        $f->setFieldNewVal('wfid', $row[0]);
        $f->setFieldNewVal('eventid', $id);
        $f->setFieldNewVal('objtype', $objtype);
        $f->setFieldNewVal('objid', $objid);
        $f->insert();
    }

}

}

?>