<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wworkflow_models_wfoper extends wPrototype
{
public $caseid = 0;

public function __construct($objtype = '', $id = '')
{
    parent::__construct('wwf_wfoper');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
}


protected function _onBeforeInsert()
{
    global $parser;
    $this->setFieldNewVal('creatby', $parser->getUserId());
    $this->setFieldNewVal('creaton', $parser->utils->toDate('', true));
    return '';
}

public function fire($caseid =0, $transid = 0)
{
    global $parser;
    if(!isset($_SESSION['wwf_wflow_trans'])) $_SESSION['wwf_wflow_trans'] = array();
    $triggertype = 0;
    $timeunits = 0;
    $timelimit = 0;
    $shortcycle = 1;
    $incbranch = 'sys_branchs_alt';
    $state = 0;
    $start = 0;
    $finish = 0;
    $id = 0;
    $subwfid = 0;

    if(!$caseid and !$transid and !$this->id) return '';
    if($caseid and $transid)
    {
        // Check for existing operation in this process
        $a = $parser->utils->getFieldsFromSql("SELECT o.id, o.state, t.triggertype,
                                              t.shortcycle, t.incbranch, t.start,
                                              t.finish, t.subwfid, t.timeunits, t.timelimit
                                              FROM wwf_wfoper o, wwf_wftrans t
                                              WHERE (o.caseid=".$caseid.")
                                              AND (o.transid=".$transid.")
                                              AND (o.transid=t.id)
                                              ", array(0, 0, 0, 1, 'sys_branchs_alt', 0, 0), 'num');
        if($a[0])
        {
            $triggertype = $a[2];
            $shortcycle = $a[3];
            $incbranch = $a[4];
            $state = $a[1];
            $start = $a[5];
            $finish = $a[6];
            $id = $a[0];
            $subwfid = $a[7];
            $timeunits = $a[8];
            $timelimit = $a[9];
        } else
        {
            // Insert operation
            $this->id = 0;
            $this->fields->id->val = 0;
            $state = 'sys_operst_en';
            $a = $parser->utils->getFieldsFromSql("SELECT triggertype, shortcycle, incbranch, start, finish,
                                                  subwfid, timeunits, timelimit
                                                  FROM wwf_wftrans
                                                  WHERE (id=".$transid.")
                                                  ", array(0, 1, 0), 'num');
            $triggertype = $a[0];
            $shortcycle = $a[1];
            $incbranch = $a[2];
            $start = $a[3];
            $finish = $a[4];
            $subwfid = $a[5];
            $timeunits = $a[6];
            $timelimit = $a[7];
            if(!$start)
            {
                // Check inputs states to fire
                switch($incbranch)
                {
                    case 'sys_branchs_alt':
                        $opf = $parser->utils->getFieldFromSql("SELECT o.id
                                              FROM wwf_wfoper o, wwf_conns c
                                              WHERE (o.caseid=".$caseid.")
                                              AND (o.transid=c.fromtrans)
                                              AND (c.totrans=".$transid.")
                                              AND (o.state='sys_operst_completed')", 0);
                        if(!$opf) return '';
                    break;
                    case 'sys_branchs_par':
                        $opf = $parser->utils->getFieldFromSql("SELECT o.id
                                              FROM wwf_wfoper o, wwf_conns c
                                              WHERE (o.caseid=".$caseid.")
                                              AND (o.transid=c.fromtrans)
                                              AND (c.totrans=".$transid.")
                                              AND (o.state<>'sys_operst_completed')", 0);
                        if($opf) return '';
                    break;
                }
            }

            $this->setFieldNewVal('state', $state);
            $this->setFieldNewVal('transid', $transid);
            $this->setFieldNewVal('caseid', $caseid);
            if($triggertype === 'sys_triggers_time')
            {
                $dtip = '';
                switch($timeunits)
                {
                    case 'sys_timeunits_day': $dtip = 'd'; break;
                    case 'sys_timeunits_mon': $dtip = 'mo'; break;
                    case 'sys_timeunits_min': $dtip = 'mi'; break;
                    case 'sys_timeunits_week': $dtip = 'd'; $timelimit *= 7; break;
                    case 'sys_timeunits_hr': $dtip = 'h'; break;
                }
                $this->setFieldNewVal('timeout', $parser->utils->shiftDates($parser->utils->toDate('', true), $timelimit, $dtip, $parser->gs('sys_user_dateformat').' H:i'));
            } else
            {
                $this->setFieldNewVal('timeout', '');
            }
            $s = $this->insert();
            if($s) return $s;
            $id = $this->id;
            if(''.$triggertype != 'sys_triggers_auto') return '';
        }
        $this->id = $id;
    } else
    {
        $a = $parser->utils->getFieldsFromSql("SELECT o.id, o.state,
                                              t.shortcycle, t.id, o.caseid,
                                              t.subwfid
                                              FROM wwf_wfoper o, wwf_wftrans t
                                              WHERE (o.id=".$this->id.")
                                              AND (o.transid=t.id)
                                              ", array(0, 0, 0, 0, 0), 'num');
        if(!$a[0]) return '';
        $shortcycle = $a[2];
        $state = $a[1];
        $caseid = $a[4];
        $transid = $a[3];
        $subwfid= $a[5];
    }

    if(!in_array($transid, $_SESSION['wwf_wflow_trans'])) $_SESSION['wwf_wflow_trans'][] = $transid;
    // Move process to the next step
    switch($state)
    {
        case 'sys_operst_en':
            if($shortcycle) return $this->finish();
            // if transition goes to subprocess then start it and return
            if($subwfid)
            {
                $b = $parser->utils->getFieldsFromSql("SELECT eventid, objtype, objid
                                                      FROM wwf_wfcase
                                                      WHERE (o.id=".$caseid.")
                                                      ", array(0, 0, 0), 'num');

                $f = new wworkflow_models_wfcase();
                $f->setFieldNewVal('wfid', $subwfid);
                $f->setFieldNewVal('eventid', $b[0]);
                $f->setFieldNewVal('parent', $caseid);
                $f->setFieldNewVal('parentoper', $this->id);
                $f->setFieldNewVal('objtype', $b[1]);
                $f->setFieldNewVal('objid', $b[2]);
                $s = $f->insert();
                if($s) return $s;
                if(!in_array($transid, $_SESSION['wwf_wflow_trans'])) $_SESSION['wwf_wflow_trans'][] = $transid;
            }
            $parser->conn->Execute("UPDATE wwf_wfoper SET state='sys_operst_inwork' WHERE id=".$this->id);
        break;
        case 'sys_operst_completed':
        case 'sys_operst_canceled':
            if(!$caseid or !$transid) return '';
            $parser->conn->Execute("DELETE FROM wwf_wfoper WHERE id=".$this->id);
            $this->id = 0;
            return $this->fire($caseid, $transid);
        break;
        case 'sys_operst_inwork':
            return $this->finish();
        break;
    }
    return '';
}

protected function finish()
{
    global $parser;
    // Check for existing operation in this process
    $a = $parser->utils->getFieldsFromSql("SELECT o.id, o.state,
                                          t.outbranch, t.start, t.finish,
                                          t.outputarcs, t.id, o.caseid,
                                          z.eventid, z.objtype, z.objid, z.parentoper, z.parent
                                          FROM wwf_wfoper o, wwf_wftrans t, wwf_wfcase z
                                          WHERE (o.id=".$this->id.")
                                          AND (o.transid=t.id)
                                          AND (o.caseid=z.id)
                                          ", array(0, 0, 'sys_branchs_alt', 0, 0), 'num');
    if(!$a[0]) return '';
    if(!in_array(''.$a[1], array('sys_operst_en', 'sys_operst_inwork'))) return '';
    $temp_id = $this->id;
    $this->read();
    $temp_state = $this->getFieldVal('state');
    $temp_time = $this->getFieldVal('finishon');
    $this->setFieldNewVal('state', 'sys_operst_completed');
    $this->setFieldNewVal('finishon', $parser->utils->toDate('', true));
    $this->setFieldAttr('state', 'ro', 0);
    $this->setFieldAttr('finishon', 'ro', 0);
    $this->setFieldAttr('cancelon', 'ro', 0);
    $s = $this->update();
    if($s) return $s;
    if(!in_array($this->getFieldVal('transid'), $_SESSION['wwf_wflow_trans'])) $_SESSION['wwf_wflow_trans'][] = $this->getFieldVal('transid');
    $mess = '';

    // Variables for script
    $caseid = $a[7];
    $transid = $a[6];
    $eventid = $a[8];
    $objtype = $a[9];
    $objid = $a[10];
    $parentoper = $a[11];
    $parent = $a[12];
    $operid = $a[0];
    $state = $a[1];

    if($a[5])
    {
        // Try to fire outputs. And only then complete operation. If it is PAR output then complete in any case
        $incbranch = '';
        $sql = "SELECT c.totrans, c.forwardcond, t.incbranch,
                u.description AS udescription, d.description AS ddescription
                FROM wwf_conns c, wwf_wftrans t, sys_objects u, sys_objects d
                WHERE (c.fromtrans=".$a[6].")
                AND (c.totrans=t.id)
                AND (c.trcond=u.objid)
                AND (c.traction=d.objid)
                ";
        //$parser->toFile($sql);
        $rs = $parser->conn->Execute($sql);
        while($row = $rs->FetchRow())
        {
            $incbranch = $row[2];
            $parser->conn->Execute("DELETE FROM wwf_wfoper WHERE caseid=".$a[7]." AND transid=".$row[0]);
            if(''.$a[2] == 'sys_branchs_alt')
            {
                // check conditions
                $cond = trim($row[3]);
                if($cond)
                {
                    $res = eval($cond);
                    if(!$res) continue;
                }
                $cond = trim($row[4]);
                if($cond)
                {
                    $res = eval($cond);
                    if(!$res) continue;
                }
                $cond = trim($row[1]);
                if($cond)
                {
                    $res = eval($cond);
                    if(!$res) continue;
                }
            }
            // Fire
            if(!in_array($row[0], $_SESSION['wwf_wflow_trans'])) $_SESSION['wwf_wflow_trans'][] = $row[0];
            $this->fire($a[7], $row[0]);
        }
        // Check outputs
        $ok = false;
        $opf = $parser->utils->getFieldFromSql("SELECT COUNT(*)
                              FROM wwf_wfoper o, wwf_conns c
                              WHERE (o.caseid=".$a[7].")
                              AND (o.transid=c.totrans)
                              AND (c.fromtrans=".$a[6].")
                              ", 0);
        switch($a[2])
        {
            case 'sys_branchs_alt':
                //$mess .= 'sys_branchs_alt';
                if($opf) $ok = true;
            break;
            case 'sys_branchs_par':
                //$mess .= 'sys_branchs_par';
                if($opf == $a[5]) $ok = true;
            break;
        }
        if(!$ok and ($incbranch != 'sys_branchs_par'))
        {
            // Undo finish
            $this->id = $temp_id;
            $this->read();
            $this->setFieldAttr('state', 'ro', 0);
            $this->setFieldAttr('finishon', 'ro', 0);
            $this->setFieldNewVal('state', $temp_state);
            $this->setFieldNewVal('finishon', $temp_time);
            $this->update();
            return $parser->gt('operblocked').'. '.$mess;
        }

        $sql = "SELECT c.fromtrans
                FROM wwf_conns c, wwf_wftrans t
                WHERE (c.totrans=".$a[6].")
                AND (c.fromtrans=t.id)
                AND (t.outbranch='sys_branchs_alt')
                AND (t.outputarcs>1)
                ";
        $rs = $parser->conn->Execute($sql);
        while($row = $rs->FetchRow())
        {
            $sqlm = "SELECT o.id, o.transid
                      FROM wwf_wfoper o, wwf_conns c
                      WHERE (o.caseid=".$a[7].")
                      AND (o.transid=c.totrans)
                      AND (c.fromtrans=".$row[0].")
                      AND (c.totrans<>".$a[6].")
                      ";
            $qs = $parser->conn->Execute($sqlm);
            while($qow = $qs->FetchRow())
            {
                $this->id = $qow[0];
                $this->read();
                $this->setFieldAttr('state', 'ro', 0);
                $this->setFieldAttr('cancelon', 'ro', 0);
                $this->setFieldNewVal('state', 'sys_operst_canceled');
                $this->setFieldNewVal('cancelon', $parser->utils->toDate('', true));
                $this->update();
                if(!in_array($qow[1], $_SESSION['wwf_wflow_trans'])) $_SESSION['wwf_wflow_trans'][] = $qow[1];
            }
        }
    }
    if($a[4])
    {
        // end of process
        // Close the process and cancel all enabled operations
        $sql = "SELECT id FROM wwf_wfoper WHERE caseid=".$a[7]." AND state IN('sys_operst_en', 'sys_operst_inwork')";
        $rs = $parser->conn->Execute($sql);
        while($row = $rs->FetchRow())
        {
            $this->id = $row[0];
            $this->read();
            $this->setFieldAttr('state', 'ro', 0);
            $this->setFieldAttr('cancelon', 'ro', 0);
            $this->setFieldNewVal('state', 'sys_operst_canceled');
            $this->setFieldNewVal('cancelon', $parser->utils->toDate('', true));
            $this->update();
            if(!in_array($this->getFieldVal('transid'), $_SESSION['wwf_wflow_trans'])) $_SESSION['wwf_wflow_trans'][] = $this->getFieldVal('transid');
        }
        $f = new wworkflow_models_wfcase();
        $f->id = $a[7];
        $f->read();
        $caseid_tmp = $this->caseid;
        $this->id = $f->getFieldVal('parentoper');
        $this->caseid = $f->getFieldVal('parent');
        $f->setFieldAttr('state', 'ro', 0);
        $f->setFieldAttr('finishon', 'ro', 0);
        $f->setFieldNewVal('state', 'wwf_dirs_casest_closed');
        $f->setFieldNewVal('finishon', $parser->utils->toDate('', true));
        $f->update();

        // if it was subprocess then fire parent operation
        if($this->id) $this->fire();
        $this->caseid = $caseid_tmp;
    }

    return '';
}

public function goback($caseid =0, $transid = 0)
{
    global $parser;
    if(!isset($_SESSION['wwf_wflow_trans'])) $_SESSION['wwf_wflow_trans'] = array();
    if(!in_array($transid, $_SESSION['wwf_wflow_trans'])) $_SESSION['wwf_wflow_trans'][] = $transid;
    if(!$caseid) return '';

    // 1. Find all pathes from this point
    $pathes = $this->getChilds($transid);
    // 2. All conditions must be true
    $s = $this->_goback($caseid, $transid, $pathes, true);
    if($s) return $s;

    // 3. Reopen process and return it to point
    $f = new wworkflow_models_wfcase();
    $f->id = $caseid;
    $f->read();
    $f->setFieldAttr('state', 'ro', 0);
    $f->setFieldNewVal('state', '0');
    $f->update();
    return $this->_goback($caseid, $transid, $pathes, false);
}

public function _goback($caseid =0, $transid = 0, $pathes = array(), $onlycheck = true)
{
    global $parser;
    $s = '';
    $f = new wworkflow_models_wfcase();

    for($k = 0; $k < sizeof($pathes); $k++)
    {
        for($j = sizeof($pathes[$k]) - 1; $j >= 0; $j--)
        {
            // Check all inputs for scripts and eval them
            $a = $parser->utils->getFieldsFromSql("SELECT o.id, o.state,
                                                  t.outbranch, t.start, t.finish,
                                                  t.outputarcs, t.id, o.caseid,
                                                  z.eventid, z.objtype, z.objid, z.parentoper,
                                                  z.parent, t.subwfid
                                                  FROM wwf_wfoper o, wwf_wftrans t, wwf_wfcase z
                                                  WHERE (o.caseid=".$caseid.")
                                                  AND (o.transid=".$pathes[$k][$j].")
                                                  AND (o.transid=t.id)
                                                  AND (o.caseid=z.id)
                                                  ", array(0, 0, 'sys_branchs_alt', 0, 0), 'num');

            if(!$a[0]) continue;

            // Variables for script
            $eventid = $a[8];
            $objtype = $a[9];
            $objid = $a[10];
            $parentoper = $a[11];
            $parent = $a[12];
            $operid = $a[0];
            $state = $a[1];
            $caseid = $a[7];
            $subwfid = $a[13];

            if($subwfid)
            {
			    $n = $parser->utils->getFieldFromSql("SELECT id
			                                          FROM wwf_wfcase
			                                          WHERE (parent=".$caseid.")
			                                          ", 0);
			    if($n)
                {
				    $f->id = $n;
				    $f->read();
				    $s = ($onlycheck) ? $f->canDelete() : $f->delete();
				    if($s) return $s;
			    }
            }

            $sql = "SELECT c.fromtrans, c.backwardcond, t.trcode, t.title
                    FROM wwf_conns c, wwf_wftrans t
                    WHERE (c.totrans=".$pathes[$k][$j].")
                    AND (c.totrans=t.id)
                    ";
            $rs = $parser->conn->Execute($sql);
            $mess = '';
            while($row = $rs->FetchRow())
            {
                // check conditions
                $cond = trim($row[1]);
                if($cond)
                {
                    $res = eval($cond);
                    if(!$res)
                    {
                        $mess = $parser->gt('cannotreturn').': '.$parser->gt('process').$caseid.', '.
                                $parser->gt('transition').' '.$row[2].' '.$row[3].'. '.$mess;
                        break;
                    }
                }
            }
            if($mess)
            {
                return $mess;
            } elseif(!$onlycheck)
            {
                // All clear.
                $rs = $parser->conn->Execute($sql);
                while($row = $rs->FetchRow())
                {
                    //$cond = trim($row[1]);
                    $b = $parser->utils->getFieldsFromSql("SELECT o.id, o.state
                                                          FROM wwf_wfoper o
                                                          WHERE (o.transid=".$row[0].")
                                                          AND (o.caseid=".$caseid.")
                                                          ", array(0, 0), 'num');
                    if(!$b[0]) continue;
                    $this->id = $b[0];
                    $this->read();
                    $this->setFieldAttr('state', 'ro', 0);
                    $this->setFieldNewVal('state', 'sys_operst_en');
                    $this->update();
                    if(!in_array($row[0], $_SESSION['wwf_wflow_trans'])) $_SESSION['wwf_wflow_trans'][] = $row[0];
                }
                $parser->conn->Execute("DELETE FROM wwf_wfoper WHERE id=".$a[0]);
                if(!in_array($pathes[$k][$j], $_SESSION['wwf_wflow_trans'])) $_SESSION['wwf_wflow_trans'][] = $pathes[$k][$j];
            }

        }
    }
    if($onlycheck) return '';
    $b = $parser->utils->getFieldsFromSql("SELECT o.id, o.state
                                          FROM wwf_wfoper o
                                          WHERE (o.transid=".$transid.")
                                          AND (o.caseid=".$caseid.")
                                          ", array(0, 0), 'num');

    $this->id = $b[0];
    $this->read();
    $this->setFieldAttr('state', 'ro', 0);
    $this->setFieldNewVal('state', 'sys_operst_en');
    $this->update();

    return $s;
}

public function getChilds($transid = 0)
{
    global $parser;
    $res = array();
    if(!$transid) return $res;
    $sql = "SELECT c.totrans
            FROM wwf_conns c
            WHERE (c.fromtrans=".$transid.")";

    $rs = $parser->conn->Execute($sql);
    $i = 0;
    while($row = $rs->FetchRow())
    {
        $a = $this->getChilds($row[0]);
        if(sizeof($a))
        {
            for($k = 0; $k < sizeof($a); $k++)
            {
                $res[$i][] = $row[0];
                for($j = 0; $j < sizeof($a[$k]); $j++) $res[$i][] = $a[$k][$j];
                $i++;
            }

        } else $res[$i++][0] = $row[0];
    }

    return $res;
}


public function handleTimers()
{
    global $parser;
    // Onl1y sys_operst_en, not in_work !!!!!
    $sql = "SELECT o.id, o.caseid, o.transid
          FROM wwf_wfoper o, wwf_wftrans t
          WHERE (o.transid=t.id)
          AND (t.triggertype='sys_triggers_time')
          AND (o.state IN('sys_operst_en'))
          AND (o.timeout<=".$parser->conn->DBTimeStamp(adodb_date('Y-m-d H:i')).")
          ";
    $rs = $parser->conn->Execute($sql);
    while($row = $rs->FetchRow())
    {
        $this->caseid = $row[1];
        $this->id = $row[0];
        $this->fire($row[1], $row[2]);
    }
}

public function handleTriggers($id = 0, $type = 0, $objtype = '0', $objid = '0')
{
    global $parser;
    if(!$type) return '';
    $sql = "SELECT o.id, o.caseid, o.transid
          FROM wwf_wfoper o, wwf_wftrans t, wwf_wfcase c
          WHERE (o.transid=t.id)
          AND (o.caseid=c.id)
          AND (t.triggertype='sys_triggers_ext')
          AND (o.state IN('sys_operst_en'))
          AND (t.eventid='".$type."')
          AND (c.objtype='".$objtype."')
          AND (c.objid='".$objid."')
          ";

    $rs = $parser->conn->Execute($sql);
    while($row = $rs->FetchRow())
    {
        $this->caseid = $row[1];
        $this->id = $row[0];
        $this->fire($row[1], $row[2]);
    }
}


}

?>